/// Generated By XFlutter Cli.
/// 
/// more info: https://medium.com/@aghiadodeh
import 'package:formz/formz.dart';

enum EmailValidationError { invalid }

class FormzEmail extends FormzInput<String, EmailValidationError> {
  const FormzEmail.pure([String value = '']) : super.pure(value);
  const FormzEmail.dirty([String value = '']) : super.dirty(value);

  static final RegExp _emailRegExp = RegExp(
    r'^[a-zA-Z0-9.!#$%&’*+/=?^_`{|}~-]+@[a-zA-Z0-9-]+(?:.[a-zA-Z0-9-]+)*$',
  );

  @override
  EmailValidationError? validator(String value) {
    if (value.trim().isEmpty) return null;
    return _emailRegExp.hasMatch(value) ? null : EmailValidationError.invalid;
  }
}

extension Explanation on EmailValidationError {
  String? get message {
    switch (this) {
      case EmailValidationError.invalid:
        return "Email not valid";
      default:
        return null;
    }
  }
}
